package testes;

import static org.junit.Assert.*;

import org.junit.Before;
import org.junit.Test;

import modelo.Universidade;

public class TesteAluno {

	Universidade universidade = new Universidade();
	
	@Before
	public void removeCursosDaTabelaCurso(){
		universidade.apagaTodosDadosDoBD();
		universidade.cadastraCurso(01, "CCO", "CTC");
		universidade.cadastraCurso(02, "SIN", "CTC");
		universidade.cadastraCurso(03, "ECA", "CTC");
		universidade.cadastraCurso(04, "EPS", "CTC");
	}
	
	@Test
	public void cadastra1AlunoSemCurso(){
		Universidade universidade = new Universidade();
		universidade.cadastraAluno(1001, "Antonio", "Trindade");
		assertEquals ("Antonio", universidade.retornaAluno(1001).retornaNome());
		assertNull (universidade.retornaAluno(1001).retornaCurso());		
	}
	
	@Test
	public void cadastra1AlunoComCurso(){
		Universidade universidade = new Universidade();
		universidade.cadastraAluno(1001, "Antonio", "Trindade", 01);
		assertEquals ("Antonio", universidade.retornaAluno(1001).retornaNome());
	}
	
	@Test
	public void cadastra2AlunosSemCurso(){
		Universidade universidade = new Universidade();
		universidade.cadastraAluno(1001, "Antonio", "Trindade");
		universidade.cadastraAluno(1005, "Maria", "Trindade");
		assertEquals ("Antonio", universidade.retornaAluno(1001).retornaNome());
		assertEquals ("Maria", universidade.retornaAluno(1005).retornaNome());
	}
	
	@Test
	public void cadastra2AlunosComMesmoCurso(){
		Universidade universidade = new Universidade();
		universidade.cadastraAluno(1001, "Antonio", "Trindade", 01);
		universidade.cadastraAluno(1005, "Maria", "Trindade", 01);
		assertEquals ("Antonio", universidade.retornaAluno(1001).retornaNome());
		assertEquals ("CCO", universidade.retornaAluno(1001).retornaCurso().retornaNome());
		assertEquals ("Maria", universidade.retornaAluno(1005).retornaNome());
		assertEquals ("CCO", universidade.retornaAluno(1005).retornaCurso().retornaNome());
	}
	
	@Test
	public void cadastra3AlunosComCursosDiferentes(){
		Universidade universidade = new Universidade();
		universidade.cadastraAluno(1001, "Antonio", "Trindade", 01);
		universidade.cadastraAluno(1005, "Maria", "Trindade", 02);
		universidade.cadastraAluno(1007, "Zezinho", "Estreito", 01);
		assertEquals ("Antonio", universidade.retornaAluno(1001).retornaNome());
		assertEquals ("CCO", universidade.retornaAluno(1001).retornaCurso().retornaNome());
		assertEquals ("Maria", universidade.retornaAluno(1005).retornaNome());
		assertEquals ("SIN", universidade.retornaAluno(1005).retornaCurso().retornaNome());
		assertEquals ("Zezinho", universidade.retornaAluno(1007).retornaNome());
		assertEquals ("CCO", universidade.retornaAluno(1007).retornaCurso().retornaNome());
	}
	
	@Test
	public void cadastra1AlunoExistenteComNovoCurso(){
		Universidade universidade = new Universidade();
		universidade.cadastraAluno(1001, "Antonio", "Trindade", 01);
		assertEquals ("Antonio", universidade.retornaAluno(1001).retornaNome());
		universidade.cadastraAluno(1001, "Antonio", "Trindade", 02);
		assertNotSame ("CCO", universidade.retornaAluno(1001).retornaCurso().retornaNome());		
		assertNotSame ("SIN", universidade.retornaAluno(1001).retornaCurso().retornaNome());		
	}
	
	@Test
	public void remove1AlunoCadastrado(){
		Universidade universidade = new Universidade();
		universidade.cadastraAluno(1001, "Antonio", "Trindade", 01);
		assertEquals ("Antonio", universidade.retornaAluno(1001).retornaNome());
		universidade.removeAluno(1001);
		assertNull (universidade.retornaAluno(1001));
	}
	
	@Test
	public void remove2AlunosCadastrados(){
		Universidade universidade = new Universidade();
		universidade.cadastraAluno(1001, "Antonio", "Trindade", 01);
		universidade.cadastraAluno(1005, "Maria", "Trindade", 02);
		universidade.cadastraAluno(1007, "Zezinho", "Estreito", 01);
		assertEquals ("Antonio", universidade.retornaAluno(1001).retornaNome());
		assertEquals ("Maria", universidade.retornaAluno(1005).retornaNome());
		assertEquals ("Zezinho", universidade.retornaAluno(1007).retornaNome());
		universidade.removeAluno(1001);
		universidade.removeAluno(1007);
		assertNull (universidade.retornaAluno(1001));
		assertEquals ("Maria", universidade.retornaAluno(1005).retornaNome());
		assertNull (universidade.retornaAluno(1007));
	}
	

}
