package testes;

import static org.junit.Assert.*;

import org.junit.Before;
import org.junit.Test;

import modelo.Curso;
import modelo.Universidade;

public class TesteCurso {

	Universidade universidade = new Universidade();
	
	@Before
	public void removeCursosDaTabelaCurso(){
		universidade.apagaTodosDadosDoBD();
	}
	
	@Test
	public void cadastra1Curso(){
		Universidade universidade = new Universidade();
		universidade.cadastraCurso(01, "CCO", "CTC");
		assertEquals ("CCO", universidade.retornaCurso(01).retornaNome());
		assertEquals ("CTC", universidade.retornaCurso(01).retornaCentro());
	}
	
	@Test
	public void cadastra2Cursos(){
		Universidade universidade = new Universidade();
		universidade.cadastraCurso(01, "CCO", "CTC");
		universidade.cadastraCurso(02, "SIN", "CTC");
		assertEquals ("CCO", universidade.retornaCurso(01).retornaNome());
		assertEquals ("CTC", universidade.retornaCurso(01).retornaCentro());
		assertEquals ("SIN", universidade.retornaCurso(02).retornaNome());
		assertEquals ("CTC", universidade.retornaCurso(02).retornaCentro());
	}
	
	@Test
	public void consultaCursoInexistente(){
		Universidade universidade = new Universidade();
		Curso curso = universidade.retornaCurso(01);
		assertNull (curso);		
	}

	@Test
	public void cadastra1CursoExistente(){
		Universidade universidade = new Universidade();
		universidade.cadastraCurso(01, "CCO", "CTC");
		assertEquals ("CCO", universidade.retornaCurso(01).retornaNome());
		universidade.cadastraCurso(01, "CCO", "CCE");
		assertNotSame ("CCO", universidade.retornaCurso(01).retornaCentro());		
		assertEquals ("CCE", universidade.retornaCurso(01).retornaCentro());
	}
	
	@Test
	public void cadastra2CursosExistentes(){
		Universidade universidade = new Universidade();
		universidade.cadastraCurso(01, "CCO", "CTC");
		universidade.cadastraCurso(02, "SIN", "CTC");
		assertEquals ("CCO", universidade.retornaCurso(01).retornaNome());
		assertEquals ("SIN", universidade.retornaCurso(02).retornaNome());
		
		universidade.cadastraCurso(01, "CCO", "CCE");
		universidade.cadastraCurso(02, "SIN", "CCS");
		
		assertEquals ("CCE", universidade.retornaCurso(01).retornaCentro());
		assertEquals ("CCS", universidade.retornaCurso(02).retornaCentro());
	}
	
	@Test
	public void remove1CursoCadastrado(){
		Universidade universidade = new Universidade();
		universidade.cadastraCurso(01, "CCO", "CTC");
		assertEquals ("CCO", universidade.retornaCurso(01).retornaNome());
		universidade.removeCurso(01);
		assertNull (universidade.retornaCurso(01));
	}
	
	@Test
	public void remove2CursosCadastrado(){
		Universidade universidade = new Universidade();
		universidade.cadastraCurso(01, "CCO", "CTC");
		universidade.cadastraCurso(02, "SIN", "CTC");
		assertEquals ("CCO", universidade.retornaCurso(01).retornaNome());
		assertEquals ("SIN", universidade.retornaCurso(02).retornaNome());

		universidade.removeCurso(01);
		assertNull (universidade.retornaCurso(01));
		assertEquals ("SIN", universidade.retornaCurso(02).retornaNome());

		universidade.removeCurso(02);
		assertNull (universidade.retornaCurso(02));
	}
	

	
}
